#include "main.h"
#include "colbl.c"
#include "zlibInterface.h"

extern u32 new_pad;

int StateSlot=0;
int bBitmap;
unsigned short bgBitmap[480*272];
unsigned char org_gbtype;

// by kwn
void save_config(void)
{
	char CfgPath[MAX_PATH];
	char *p;
	
	_strcpy(CfgPath, RinPath);
	p = _strrchr(CfgPath, '/')+1;
	_strcpy(p, "RIN.CFG");

	int fd;
	fd = sceIoOpen(CfgPath,O_CREAT|O_WRONLY|O_TRUNC, 0777);
	if(fd>=0){
		sceIoWrite(fd, &setting, sizeof(setting));
		sceIoClose(fd);
	}
}

// by kwn
void load_config(void)
{
	int i;
	char CfgPath[MAX_PATH];
	char *p;
	
	_memset(&setting, 0, sizeof(setting));
	
	_strcpy(CfgPath, RinPath);
	p = _strrchr(CfgPath, '/')+1;
	_strcpy(p, "RIN.CFG");

	int fd;
	fd = sceIoOpen(CfgPath,O_RDONLY, 0777);
	if(fd>=0){
		sceIoRead(fd, &setting, sizeof(setting));
		sceIoClose(fd);
		if(setting.key_config[6]==0)
			setting.key_config[6] = CTRL_TRIANGLE;
		if(setting.bgbright<0 || setting.bgbright>100)
			setting.bgbright=100;
		if(setting.sound_buffer<0 || setting.sound_buffer>1)
			setting.sound_buffer = 0;
		if(setting.gb_type==2 || setting.gb_type<0 || setting.gb_type>4)
			setting.gb_type = 0;
		if(!_strcmp(setting.vercnf, "RINv1.13"))
			return;
	}

	_strcpy(setting.vercnf, "RINv1.13");
	setting.screensize = 0;
	setting.vsync = 0;
	setting.sound = 1;
	setting.key_config[0] = CTRL_CIRCLE;
	setting.key_config[1] = CTRL_CROSS;
	setting.key_config[2] = CTRL_TRIANGLE;
	setting.key_config[3] = CTRL_SQUARE;
	setting.key_config[4] = CTRL_SELECT;
	setting.key_config[5] = CTRL_START;
	setting.key_config[6] = CTRL_LTRIGGER;
	setting.key_config[7] = 0;
	setting.key_config[8] = 0;
	setting.key_config[9] = 0;
	setting.key_config[10] = 0;
	setting.key_config[11] = CTRL_RTRIGGER|CTRL_SELECT;
	setting.key_config[12] = CTRL_RTRIGGER|CTRL_START;
	setting.key_config[13] = 0;
	for(i=14; i<16; i++)
		setting.key_config[i] = 0;
	setting.color[0] = DEF_COLOR0;
	setting.color[1] = DEF_COLOR1;
	setting.color[2] = DEF_COLOR2;
	setting.color[3] = DEF_COLOR3;
	setting.wait = 1;
	setting.bgbright=100;
	setting.analog2dpad=1;
	setting.sound_buffer = 0;
	setting.gb_type = 0;
}

int save_sram(byte *buf,int size)
{
	int fd, tmp;
	int sram_tbl[]={1,1,1,4,16,8};

	fd = sceIoOpen(SavePath,O_CREAT|O_WRONLY|O_TRUNC, 0777);
	if(fd>=0){
		sceIoWrite(fd, buf, 0x2000*sram_tbl[size]);
		if ((rom_get_info()->cart_type>=0x0f)&&(rom_get_info()->cart_type<=0x13)){
			tmp=renderer_get_timer_state();
			sceIoWrite(fd, &tmp, 4);
		}
		sceIoClose(fd);
		return 1;
	}else
		return 0;
}

int load_sram(void)
{
	int fd;
	int ramsize;
	char *p;
	
	_strcpy(SavePath, RomPath);
	p = _strrchr(SavePath, '.');
	_strcpy(p, ".sav");
	fd=sceIoOpen(SavePath, O_RDONLY, 0777);
	
	if(fd<0){
		_strcpy(SavePath,RinPath);
		_strcat(SavePath,"save/");
		_strcat(SavePath,RomName);
		p = _strrchr(SavePath, '.');
		_strcpy(p, ".sav");
		fd=sceIoOpen(SavePath, O_RDONLY, 0777);
	}
	
	if(fd<0){
		_strcpy(SavePath,RinPath);
		_strcat(SavePath,"SAVE/");
		_strcat(SavePath,RomName);
		p = _strrchr(SavePath,'.');
		_strcpy(p, ".sav");
		return 0;
	}
	
	ramsize = sceIoRead(fd, sram_space, 16*0x2000+4);
	if(ramsize & 4)
		renderer_set_timer_state(*(int*)(sram_space+ramsize-4));
	sceIoClose(fd);
	return ramsize;
}

void set_gb_type()
{
	if(setting.gb_type==0){
		rom_image[0x143]&=0x7f;
		rom_image[0x143]|=org_gbtype&0x80;
		use_gba = 0;
	}else if(setting.gb_type==1){
		rom_image[0x143]&=0x7f;
		use_gba = 0;
	}else if(setting.gb_type==3){
		rom_image[0x143]|=0x80;
		use_gba = 0;
	}else if(setting.gb_type==4){
		rom_image[0x143]|=0x80;
		use_gba = 1;
	}
}

// Unzip Ή by ruka

// R[obN󂯓np
typedef struct {
	byte *p_rom_image;			// pointer to rom image
	long rom_size;				// rom size
	char szFileName[MAXPATH];	// extracted file name
}ROM_INFO, *LPROM_INFO;

// Ȃ̂ŃvOXłoĂ݂܂
void draw_load_rom_progress(unsigned long ulExtractSize, unsigned long ulCurrentPosition)
{
	int nPer = 100 * ulExtractSize / ulCurrentPosition;
	static int nOldPer = 0;
	if (nOldPer == nPer & 0xFFFFFFFE) {
		return ;
	}
	nOldPer = nPer;
	if(bBitmap)
		pgBitBlt(0,0,480,272,1,bgBitmap);
	else
		pgFillvram(setting.color[0]);
	// vOX
	pgDrawFrame(89,121,391,141,setting.color[1]);
	pgFillBox(90,123, 90+nPer*3, 139,setting.color[1]);
	// 
	char szPer[16];
	_itoa(nPer, szPer);
	_strcat(szPer, "%");
	pgPrint(28,16,setting.color[3],szPer);
	// pgScreenFlipV()gpgWaitVĂ΂Ă܂̂łŁB
	// vOX炿Ăǂˁ`
	pgScreenFlip();
}

// Unzip R[obN
int funcUnzipCallback(int nCallbackId, unsigned long ulExtractSize, unsigned long ulCurrentPosition,
                      const void *pData, unsigned long ulDataSize, unsigned long ulUserData)
{
    const char *pszFileName;
    int nExtId;
    const unsigned char *pbData;
    LPROM_INFO pRomInfo = (LPROM_INFO)ulUserData;

    switch(nCallbackId) {
    case UZCB_FIND_FILE:
		pszFileName = (const char *)pData;
		nExtId = getExtId(pszFileName);
		// gqGBGBCȂWJ
		if (nExtId == EXT_GB || nExtId == EXT_GBC) {
			// WJ閼OArom sizeoĂ
			_strcpy(pRomInfo->szFileName, pszFileName);
			pRomInfo->rom_size = ulExtractSize;
			return UZCBR_OK;
		}
        break;
    case UZCB_EXTRACT_PROGRESS:
		pbData = (const unsigned char *)pData;
		// WJꂽf[^i[悤
		_memcpy(pRomInfo->p_rom_image + ulCurrentPosition, pbData, ulDataSize);
		draw_load_rom_progress(ulCurrentPosition + ulDataSize, ulExtractSize);
		return UZCBR_OK;
        break;
    default: // unknown...
		pgFillvram(RGB(255,0,0));
		mh_print(0,0,"Unzip fatal error.",0xFFFF);
		pgScreenFlipV();
        break;
    }
    return UZCBR_PASS;
}



// load rom image by ruka
long load_rom(const char *szRomPath)
{
	int fd;
	long lReadSize=0;
	ROM_INFO stRomInfo;
	int nRet;
	int nExtId = getExtId(szRomPath);
	switch(nExtId) {
	case EXT_GB:	// "gb"
	case EXT_GBC:	// "gbc"
		fd=sceIoOpen(szRomPath, O_RDONLY, 0777);
		lReadSize = sceIoRead(fd, rom_image, 8*1024*1024);
		sceIoClose(fd);
		break;
	case EXT_ZIP:	// "zip"
		stRomInfo.p_rom_image = rom_image;
		stRomInfo.rom_size = 0;
		_memset(stRomInfo.szFileName, 0x00, sizeof(stRomInfo.szFileName));
		// UnzipR[obNZbg
		Unzip_setCallback(funcUnzipCallback);
		// UnzipWJ
	    nRet = Unzip_execExtract(szRomPath, (unsigned long)&stRomInfo);
		if (nRet != UZEXR_OK) {
			// ǂݍݎsI - ̃R[hł́AUZEXR_CANCELɗ
			// ܂R[obNŃLZĂȂ̂Ŗ
			lReadSize = 0;
			pgFillvram(RGB(255,0,0));
			mh_print(0,0,"Unzip fatal error.",0xFFFF);
			pgScreenFlipV();
		}
		lReadSize = stRomInfo.rom_size;
		break;
	default:
		lReadSize = 0;
		break;
	}
	
	if(lReadSize>0){
		org_gbtype = rom_image[0x143]&0x80;
		set_gb_type();
	}
	
	return lReadSize;
}

int save_state(void)
{
	int fd;
	char path[MAX_PATH], *p, ext[5];
	
	_strcpy(ext, ".sv0");
	ext[3]=StateSlot+'0';
	
	_strcpy(path, SavePath);
	p = _strrchr(path, '.');
	_strcpy(p, ext);
	fd = sceIoOpen(path,O_CREAT|O_WRONLY|O_TRUNC, 0777);
	if(fd>=0){
		gb_save_state(fd);
		sceIoClose(fd);
		return 1;
	}else
		return 0;
}

int load_state(void){
	int fd;
	char path[MAX_PATH], *p, ext[5];
	
	_strcpy(ext, ".sv0");
	ext[3]=StateSlot+'0';
	
	_strcpy(path, SavePath);
	p = _strrchr(path, '.');
	_strcpy(p, ext);
	fd = sceIoOpen(path,O_RDONLY, 0777);
	if(fd>=0){
		gb_restore_state(fd);
		sceIoClose(fd);
		return 1;
	}else
		return 0;
}

// by kwn
void load_menu_bg()
{
	byte *menu_bg;
	unsigned char *vptr;
	static byte menu_bg_buf[480*272*3+0x36];
	char BgPath[MAX_PATH];
	char *p;
 	unsigned short x,y,yy,r,g,b,data;

	getDir(RinPath);
	_strcpy(BgPath, RinPath);
	p = _strrchr(BgPath, '/')+1;
	_strcpy(p, "RINMENU.BMP");

	int fd;
	fd = sceIoOpen(BgPath,O_RDONLY,0777);
	if(fd>=0){
		sceIoRead(fd, menu_bg_buf, 480*272*3+0x36);
		sceIoClose(fd);

		menu_bg = menu_bg_buf + 0x36;
		vptr=(unsigned char*)bgBitmap;
		for(y=0; y<272; y++){
			for(x=0; x<480; x++){
				yy = 271 - y;
				r = *(menu_bg + (yy*480 + x)*3 + 2);
				g = *(menu_bg + (yy*480 + x)*3 + 1);
				b = *(menu_bg + (yy*480 + x)*3);
				data = (((b & 0xf8) << 7) | ((g & 0xf8) << 2) | (r >> 3));
				*(unsigned short *)vptr=data;
				vptr+=2;
			}
		}
		bBitmap = 1;
	}else{
		bBitmap = 0;
	}
}

// 
unsigned short rgbTransp(unsigned short fgRGB, unsigned short bgRGB, int alpha) {

    unsigned short fgR, fgG, fgB;
    unsigned short bgR, bgG, bgB;
	unsigned short R, G, B;
 	unsigned short rgb;

    fgB = (fgRGB >> 10) & 0x1F;
    fgG = (fgRGB >> 5) & 0x1F;
    fgR = fgRGB & 0x1F;

    bgB = (bgRGB >> 10) & 0x1F;
    bgG = (bgRGB >> 5) & 0x1F;
    bgR = bgRGB & 0x1F;

	R = coltbl[fgR][bgR][alpha/10];
	G = coltbl[fgG][bgG][alpha/10];
	B = coltbl[fgB][bgB][alpha/10];

	rgb = (((B & 0x1F)<<10)+((G & 0x1F)<<5)+((R & 0x1F)<<0)+0x8000);
    return rgb;
}

void bgbright_change()
{
	unsigned short *vptr,rgb;
 	int i;

//	load_menu_bg();
	vptr=bgBitmap;
	for(i=0; i<272*480; i++){
			rgb = *vptr;
			*vptr = rgbTransp(rgb, 0x0000, setting.bgbright);
			vptr++;
	}
}

void rin_frame(const char *msg0, const char *msg1)
{
	if(bBitmap)
		pgBitBlt(0,0,480,272,1,bgBitmap);
	else
		pgFillvram(setting.color[0]);
	mh_print(360, 0, "  qhm Ver1.17 ", setting.color[1]);
	// bZ[WȂ
	if(msg0!=0) mh_print(17, 14, msg0, setting.color[2]);
	pgDrawFrame(17,25,463,248,setting.color[1]);
	pgDrawFrame(18,26,462,247,setting.color[1]);
	// 
	if(msg1!=0) mh_print(17, 252, msg1, setting.color[2]);
}

void rin_colorconfig(void)
{
	enum
	{
		COLOR0_R=0,
		COLOR0_G,
		COLOR0_B,
		COLOR1_R,
		COLOR1_G,
		COLOR1_B,
		COLOR2_R,
		COLOR2_G,
		COLOR2_B,
		COLOR3_R,
		COLOR3_G,
		COLOR3_B,
		BG_BRIGHT,
		EXIT,
		INIT,
	};
	char tmp[4], msg[256];
	int color[4][3];
	int sel=0, x, y, i;

	_memset(color, 0, sizeof(int)*4*3);
	for(i=0; i<4; i++){
		color[i][2] = setting.color[i]>>10 & 0x1F;
		color[i][1] = setting.color[i]>>5 & 0x1F;
		color[i][0] = setting.color[i] & 0x1F;
	}

	for(;;){
		readpad();
		if(new_pad & CTRL_CIRCLE){
			if(sel==EXIT){
				break;
			}else if(sel==INIT){
				color[0][2] = DEF_COLOR0>>10 & 0x1F;
				color[0][1] = DEF_COLOR0>>5 & 0x1F;
				color[0][0] = DEF_COLOR0 & 0x1F;
				color[1][2] = DEF_COLOR1>>10 & 0x1F;
				color[1][1] = DEF_COLOR1>>5 & 0x1F;
				color[1][0] = DEF_COLOR1 & 0x1F;
				color[2][2] = DEF_COLOR2>>10 & 0x1F;
				color[2][1] = DEF_COLOR2>>5 & 0x1F;
				color[2][0] = DEF_COLOR2 & 0x1F;
				color[3][2] = DEF_COLOR3>>10 & 0x1F;
				color[3][1] = DEF_COLOR3>>5 & 0x1F;
				color[3][0] = DEF_COLOR3 & 0x1F;
				setting.bgbright = 100;
				if(bBitmap){
					load_menu_bg();
					bgbright_change();
				}
			}else if(sel == BG_BRIGHT) {
				//PxύX
				setting.bgbright += 10;
				if(setting.bgbright > 100) setting.bgbright=0;
				if(bBitmap){
					load_menu_bg();
					bgbright_change();
				}
			}else{
				if(color[sel/3][sel%3]<31)
					color[sel/3][sel%3]++;
			}
		}else if(new_pad & CTRL_CROSS){
			if(sel == BG_BRIGHT) {
				//PxύX
				setting.bgbright -= 10;
				if(setting.bgbright < 0) setting.bgbright=100;
				if(bBitmap){
					load_menu_bg();
					bgbright_change();
				}
			}else if(sel>=COLOR0_R && sel<=COLOR3_B){
				if(color[sel/3][sel%3]>0)
					color[sel/3][sel%3]--;
			}
		}else if(new_pad & CTRL_UP){
			if(sel!=0)	sel--;
			else		sel=INIT;
		}else if(new_pad & CTRL_DOWN){
			if(sel!=INIT)	sel++;
			else			sel=0;
		}else if(new_pad & CTRL_RIGHT){
			if(sel<COLOR1_R) 		sel=COLOR1_R;
			else if(sel<COLOR2_R)	sel=COLOR2_R;
			else if(sel<COLOR3_R)	sel=COLOR3_R;
			else if(sel<BG_BRIGHT)	sel=BG_BRIGHT;
			else if(sel<EXIT)		sel=EXIT;
		}else if(new_pad & CTRL_LEFT){
			if(sel>BG_BRIGHT)		sel=BG_BRIGHT;
			else if(sel>COLOR3_B)	sel=COLOR3_R;
			else if(sel>COLOR2_B)	sel=COLOR2_R;
			else if(sel>COLOR1_B)	sel=COLOR1_R;
			else					sel=COLOR0_R;
		}

		for(i=0; i<4; i++)
			setting.color[i]=color[i][2]<<10|color[i][1]<<5|color[i][0]|0x8000;

		x = 2;
		y = 5;

		if(sel>=COLOR0_R && sel<=BG_BRIGHT)
			_strcpy(msg, "FAdd@~FAway");
		else
			_strcpy(msg, "FOK");

		rin_frame(0, msg);

		pgPrint(x,y++,setting.color[3],"  COLOR0 R:");
		pgPrint(x,y++,setting.color[3],"  COLOR0 G:");
		pgPrint(x,y++,setting.color[3],"  COLOR0 B:");
		y++;
		pgPrint(x,y++,setting.color[3],"  COLOR1 R:");
		pgPrint(x,y++,setting.color[3],"  COLOR1 G:");
		pgPrint(x,y++,setting.color[3],"  COLOR1 B:");
		y++;
		pgPrint(x,y++,setting.color[3],"  COLOR2 R:");
		pgPrint(x,y++,setting.color[3],"  COLOR2 G:");
		pgPrint(x,y++,setting.color[3],"  COLOR2 B:");
		y++;
		pgPrint(x,y++,setting.color[3],"  COLOR3 R:");
		pgPrint(x,y++,setting.color[3],"  COLOR3 G:");
		pgPrint(x,y++,setting.color[3],"  COLOR3 B:");
		y++;
		if(setting.bgbright / 100 == 1)
			pgPrint(x,y++,setting.color[3],"  BG BRIGHT:100%");
		else
			pgPrint(x,y++,setting.color[3],"  BG BRIGHT:  0%");
		if(setting.bgbright % 100 != 0)			// 10%`90%
			pgPutChar((x+13)*8,(y-1)*8,setting.color[3],0,'0'+setting.bgbright/10,1,0,1);
		y++;
		pgPrint(x,y++,setting.color[3],"  Return to Main Menu");
		pgPrint(x,y++,setting.color[3],"  Initialize");

		x=14; y=5;
		for(i=0; i<12; i++){
			if(i!=0 && i%3==0) y++;
			_itoa(color[i/3][i%3], tmp);
			pgPrint(x,y++,setting.color[3],tmp);
		}

		x = 2;
		y = sel + 5;
		if(sel>=COLOR1_R) y++;
		if(sel>=COLOR2_R) y++;
		if(sel>=COLOR3_R) y++;
		if(sel>=BG_BRIGHT) y++;
		if(sel>=EXIT) y++;
		pgPutChar((x+1)*8,y*8,setting.color[3],0,127,1,0,1);

		pgScreenFlipV();
	}
}

// by kwn
void rin_keyconfig(void)
{
	enum
	{
		CONFIG_A = 0,
		CONFIG_B,
		CONFIG_RAPIDA,
		CONFIG_RAPIDB,
		CONFIG_SELECT,
		CONFIG_START,
		CONFIG_MENU,
		CONFIG_WAIT,
		CONFIG_VSYNC,
		CONFIG_SOUND,
		CONFIG_SCREENSIZE,
		CONFIG_QUICKSAVE,
		CONFIG_QUICKLOAD,
		CONFIG_STATE_SLOT,
		CONFIG_ANALOG2DPAD,
		CONFIG_EXIT,
	};
	char msg[256];
	int sel=0, x, y, i, bPad;
	
	pgWaitVn(15);
	
	for(;;){
		readpad();
		if(now_pad==CTRL_LEFT || now_pad==CTRL_RIGHT){
			if(sel!=CONFIG_EXIT && sel!=CONFIG_MENU && sel!=CONFIG_ANALOG2DPAD)
				setting.key_config[sel] = 0;
		}else if(now_pad==CTRL_UP){
			if(bPad==0){
				if(sel!=0)	sel--;
				else		sel=CONFIG_EXIT;
				bPad++;
			}else if(bPad >= 25){
				if(sel!=0)	sel--;
				else		sel=CONFIG_EXIT;
				bPad=20;
			}else
				bPad++;
		}else if(now_pad==CTRL_DOWN){
			if(bPad==0){
				if(sel!=CONFIG_EXIT)sel++;
				else				sel=0;
				bPad++;
			}else if(bPad >= 25){
				if(sel!=CONFIG_EXIT)sel++;
				else				sel=0;
				bPad=20;
			}else
				bPad++;
		}else if(new_pad != 0){
			if(sel==CONFIG_EXIT && new_pad&CTRL_CIRCLE)
				break;
			else if(sel==CONFIG_ANALOG2DPAD && new_pad&CTRL_CIRCLE)
				setting.analog2dpad = !setting.analog2dpad;
			else
				setting.key_config[sel] = now_pad;
		}else{
			bPad=0;
		}
		
		if(sel>=CONFIG_ANALOG2DPAD)
			_strcpy(msg,"FOK");
		else
			_strcpy(msg,"");
		
		rin_frame(0, msg);
		
		x=2; y=5;
		pgPrint(x,y++,setting.color[3],"  A BUTTON       :");
		pgPrint(x,y++,setting.color[3],"  B BUTTON       :");
		pgPrint(x,y++,setting.color[3],"  A BUTTON(RAPID):");
		pgPrint(x,y++,setting.color[3],"  B BUTTON(RAPID):");
		pgPrint(x,y++,setting.color[3],"  SELECT BUTTON  :");
		pgPrint(x,y++,setting.color[3],"  START BUTTON   :");
		pgPrint(x,y++,setting.color[3],"  MENU BUTTON    :");
		pgPrint(x,y++,setting.color[3],"  WAIT ON/OFF    :");
		pgPrint(x,y++,setting.color[3],"  VSYNC ON/OFF   :");
		pgPrint(x,y++,setting.color[3],"  SOUND ON/OFF   :");
		pgPrint(x,y++,setting.color[3],"  SCREEN SIZE    :");
		pgPrint(x,y++,setting.color[3],"  QUICK SAVE     :");
		pgPrint(x,y++,setting.color[3],"  QUICK LOAD     :");
		pgPrint(x,y++,setting.color[3],"  STATE SLOT     :");
		y++;
		if(setting.analog2dpad)
			pgPrint(x,y++,setting.color[3],"  AnalogPad to D-Pad: ON");
		else
			pgPrint(x,y++,setting.color[3],"  AnalogPad to D-Pad: OFF");
		y++;
		pgPrint(x,y++,setting.color[3],"  Return to Main Menu");
		
		for (i=0; i<CONFIG_ANALOG2DPAD; i++){
			y = i + 5;
			int j = 0;
			msg[0]=0;
			if(setting.key_config[i] == 0){
				_strcpy(msg,"UNDEFINED");
			}else{
				if (setting.key_config[i] & CTRL_LTRIGGER){
					msg[j++]='L'; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_RTRIGGER){
					msg[j++]='R'; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_CIRCLE){
					msg[j++]=1; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_CROSS){
					msg[j++]=2; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_SQUARE){
					msg[j++]=3; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_TRIANGLE){
					msg[j++]=4; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_START){
					_strcat(msg,"START+"); j+=6;
				}
				if (setting.key_config[i] & CTRL_SELECT){
					_strcat(msg,"SELECT+"); j+=7;
				}
				if (setting.key_config[i] & CTRL_UP){
					msg[j++]=5; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_RIGHT){
					msg[j++]=6; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_DOWN){
					msg[j++]=7; msg[j++]='+'; msg[j]=0;
				}
				if (setting.key_config[i] & CTRL_LEFT){
					msg[j++]=8; msg[j++]='+'; msg[j]=0;
				}
				msg[_strlen(msg)-1]=0;
			}
			pgPrint(21,y,setting.color[3],msg);
		}
		
		x = 2;
		y = sel + 5;
		if(sel >= CONFIG_ANALOG2DPAD) y++;
		if(sel >= CONFIG_EXIT)        y++;
		pgPutChar((x+1)*8,y*8,setting.color[3],0,127,1,0,1);
		
		pgScreenFlipV();
	}
	
}

void rin_menu(void)
{
	enum
	{
		STATE_SLOT=0,
		STATE_SAVE,
		STATE_LOAD,
		SCREEN_SIZE,
		VSYNC,
		SOUND,
		WAIT,
		GB_TYPE,
		SOUND_BUFFER,
		COLOR_CONFIG,
		KEY_CONFIG,
		LOAD_ROM,
		RESET,
		CONTINUE,
	};
	char msg[256], path[MAX_PATH];
	int sel=0, x, y;
	int bSave, fd, romsize, ramsize;
	char *p;
	
	msg[0]=0;
	
	for(;;){
		readpad();
		if(new_pad & CTRL_CIRCLE){
			if(sel == STATE_SLOT){
				StateSlot++;
				if(StateSlot>STATE_SLOT_MAX) StateSlot=0;
			}else if(sel == STATE_SAVE){
				if(save_state())
					_strcpy(msg, "State Saved Successfully");
				else
					_strcpy(msg, "State Save Failed");
			}else if(sel == STATE_LOAD){
				if(load_state())
					_strcpy(msg, "State Loaded Successfully");
				else
					_strcpy(msg, "State Load Failed");
			}else if(sel == SCREEN_SIZE){
				setting.screensize++;
				if(setting.screensize>7) setting.screensize=0;
			}else if(sel == VSYNC){
				setting.vsync = !setting.vsync;
			}else if(sel == SOUND){
				setting.sound = !setting.sound;
			}else if(sel == WAIT){
				setting.wait = !setting.wait;
			}else if(sel == GB_TYPE){
				setting.gb_type++;
				if(setting.gb_type==2) setting.gb_type++;
				if(setting.gb_type>4) setting.gb_type=0;
				set_gb_type();
				gb_reset();
			}else if(sel == SOUND_BUFFER){
				setting.sound_buffer++ ;
				if(setting.sound_buffer>1) setting.sound_buffer=0;
			}else if(sel == COLOR_CONFIG){
				rin_colorconfig();
				msg[0]=0;
			}else if(sel == KEY_CONFIG){
				rin_keyconfig();
				msg[0]=0;
			}else if(sel == LOAD_ROM){
				FilerMsg[0]=0;
				if(getFilePath(RomPath)==true){
					// by Smiths
					if(rom_has_battery())
						save_sram(get_sram(), rom_get_info()->ram_size);
					gb_init();
					StateSlot=0;
					for(;;){
						// w肵t@C[hB by ruka
						romsize = load_rom(RomPath);
						if(!romsize){
							while(!getFilePath(RomPath))
								;
							continue;
						}
						
						p = _strrchr(RomPath,'/');
						_strcpy(RomName, p+1);
						
						ramsize = load_sram();
						if(ramsize)
							bSave = 1;
						else
							bSave = 0;
						
						if(gb_load_rom(rom_image, romsize, bSave?sram_space:0, bSave?ramsize:0))
							break;
						else{
							while(!getFilePath(RomPath))
								;
							continue;
						}
					}
					break;
				}
			}else if(sel == RESET){
				gb_reset();
				break;
			}else if(sel == CONTINUE){
				break;
			}
		}else if(new_pad & CTRL_CROSS){
			break;
		}else if(new_pad & CTRL_UP){
			if(sel!=0)
				sel--;
			else
				sel=CONTINUE;
		}else if(new_pad & CTRL_DOWN){
			if(sel!=CONTINUE)	sel++;
			else				sel=0;
		}else if(new_pad & CTRL_LEFT){
			if(sel>KEY_CONFIG) sel=SCREEN_SIZE;
			else if(sel>STATE_SLOT) sel=STATE_SLOT;
		}else if(new_pad & CTRL_RIGHT){
			if(sel<SCREEN_SIZE) sel=SCREEN_SIZE;
			else if(sel<LOAD_ROM) sel=LOAD_ROM;
		}
		
		rin_frame(msg, "FOK@~FCANCEL");
		
		x = 2;
		y = 5;
		
		pgPrint(x,y,setting.color[3],"  STATE SLOT:");
		pgPutChar((13+x)*8,y*8,setting.color[3],0,StateSlot+'0',1,0,1);
		y++;
		
		pgPrint(x,y++,setting.color[3],"  STATE SAVE");
		pgPrint(x,y++,setting.color[3],"  STATE LOAD");
		y++;

		if(setting.screensize==0)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x1");
		else if(setting.screensize==1)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x1.5 (filtered)");
		else if(setting.screensize==2)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x2 (uncropped)");
		else if(setting.screensize==3)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x2 (fit)");
		else if(setting.screensize==4)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x2 (scanline)");
		else if(setting.screensize==5)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x2 (uncropped without top)");
		else if(setting.screensize==6)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: x2 (uncropped without bottom)");
		else if(setting.screensize==7)
			pgPrint(x,y++,setting.color[3],"  SCREEN SIZE: FULL");
		
		if(setting.vsync)
			pgPrint(x,y++,setting.color[3],"  VSYNC:ON");
		else
			pgPrint(x,y++,setting.color[3],"  VSYNC:OFF");
		
		if(setting.sound)
			pgPrint(x,y++,setting.color[3],"  SOUND:ON");
		else
			pgPrint(x,y++,setting.color[3],"  SOUND:OFF");
		
		if(setting.wait)
			pgPrint(x,y++,setting.color[3],"  WAIT :ON");
		else
			pgPrint(x,y++,setting.color[3],"  WAIT :OFF");
		
		if(setting.gb_type == 0)
			pgPrint(x,y++,setting.color[3],"  GB TYPE:AUTO");
		else if(setting.gb_type == 1)
			pgPrint(x,y++,setting.color[3],"  GB TYPE:GB");
		else if(setting.gb_type == 3)
			pgPrint(x,y++,setting.color[3],"  GB TYPE:GBC");
		else if(setting.gb_type == 4)
			pgPrint(x,y++,setting.color[3],"  GB TYPE:GBA");
		
		if(setting.sound_buffer == 0)
			pgPrint(x,y++,setting.color[3],"  SOUND BUFFER:FAST");
		else
			pgPrint(x,y++,setting.color[3],"  SOUND BUFFER:SLOW");
		
		pgPrint(x,y++,setting.color[3],"  COLOR CONFIG");
		pgPrint(x,y++,setting.color[3],"  KEY CONFIG");
		y++;
		pgPrint(x,y++,setting.color[3],"  Back to ROM list");
		pgPrint(x,y++,setting.color[3],"  Reset");
		pgPrint(x,y++,setting.color[3],"  Continue");
		
		y = sel + 5;
		if(sel >= SCREEN_SIZE)	y++;
		if(sel >= LOAD_ROM)		y++;

		pgPutChar((x+1)*8,y*8,setting.color[3],0,127,1,0,1);

		pgScreenFlipV();
	}

//	save_config();

	pgFillvram(0);
	pgScreenFlipV();
	pgFillvram(0);
	pgScreenFlipV();
	pgWaitVn(10);
	_memset(&paddata, 0x00, sizeof(paddata));
}
